Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 1578 by niro, Wed Dec 28 10:54:49 2011 UTC branches/mage-next/src/smage2.in revision 2743 by niro, Tue Aug 12 21:56:54 2014 UTC
# Line 7  Line 7 
7  # TODO: record dynlib, gz | xz database  # TODO: record dynlib, gz | xz database
8    
9    
10  # set default user mage.rc  # set default variables
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="@@SYSCONFDIR@@/mage.rc"}
12    : ${MLIBDIR="@@MAGELIBDIR@@"}
13    
14  ## setup ##  # export default C locale
15  SMAGENAME="$1"  export LC_ALL=C
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 # export default C locale  
 export LC_ALL=C  
   
 source /etc/mage.rc.global  
 source ${MAGERC}  
 source ${MLIBDIR}/mage4.functions.sh  
   
 # set PKGDIR and BUILDDIR and BINDIR to MROOT  
 if [[ -n ${MROOT} ]]  
 then  
  export PKGDIR=${MROOT}/${PKGDIR}  
  export BUILDDIR=${MROOT}/${BUILDDIR}  
  export BINDIR=${MROOT}/${BINDIR}  
 fi  
   
 # sources the smage file and uses state from distribution file if exist  
 # may helpful for repository support later on  
 smagesource()  
 {  
  local file="$1"  
  local mystate  
  local mycodename  
   
  source ${file}  
   
  [[ -n ${STATE} ]] && mystate="${STATE}"  
   
  # do not overide if local state was broken or disabled!  
  case ${STATE} in  
  broken) return ;;  
  disabled) return ;;  
  esac  
   
  if [ -f ${SMAGESCRIPTSDIR}/distribution ]  
  then  
  source ${SMAGESCRIPTSDIR}/distribution  
  [[ -n ${STATE} ]] && mystate="${STATE}"  
  fi  
  # now switch state and export it  
  STATE="${mystate}"  
 }  
   
 showversion()  
 {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die()  
 {  
  xtitleclean  
  echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 die_pipestatus()  
 {  
  # the status change if we do any parameter declarations!!  
  # dont do this anymore, keep this in mind!  
  #  
  # local pos="$1"  
  # local comment="$2"  
  #  
  # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"  
  #  
  [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"  
 }  
   
 xtitle()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2()  
 {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  done  
   
  # clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum()  
 {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources()  
 {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
  local wget_opts  
   
  # filter wget command if busybox was found  
  wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"  
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? = 0 ]]  
  then  
  # md5's ok, no fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # create the SOURCEDIR  
  install -d ${my_SOURCEDIR}  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \  
  "${my_SRC_URI}"  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_prepare()  
 {  
  echo "no src_prepare defined"  
  return 0  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_compile()  
 {  
  echo "no src_compile defined"  
  return 0  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_check()  
 {  
  echo "no src_check defined"  
  return 0  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_install()  
 {  
  echo "no src_install defined"  
  return 0  
 }  
   
 mlibdir()  
 {  
  local libdir=lib  
  [[ ${ARCH} = x86_64 ]] && libdir=lib64  
   
  echo "${libdir}"  
 }  
   
 mconfigure()  
 {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --build=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  --libdir=/usr/$(mlibdir) \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall()  
 {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ]  
  then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  libdir=${BINDIR}/usr/$(mlibdir) \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake()  
 {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack()  
 {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [[ -z $2 ]]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  [[ ! -d ${DEST} ]] && install -d ${DEST}  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  xz)  
  IFTAR="$(basename $SRCFILE .xz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  tbz2|mpks|mpk)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."  
  ;;  
  txz|mpkzs|mpkz)  
  tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."  
  ;;  
  rar)  
  unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."  
  ;;  
  zip|xpi)  
  unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."  
  ;;  
  rpm)  
  pushd ${DEST} > /dev/null  
  rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."  
  tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."  
  if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]  
  then  
  rm ${DEST}/${SRCFILE/.rpm/.tar.gz}  
  fi  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch()  
 {  
  local PATCHOPTS  
  local PATCHFILE  
  local i  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  if [[ -z $2 ]]  
  then  
  PATCHFILE=$1  
   
  ## patch level auto-detection, get patch level  
  for ((i=0; i < 10; i++))  
  do  
  patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null  
  if [[ $? = 0 ]]  
  then  
  PATCHOPTS="-Np${i}"  
  break  
  fi  
  done  
  fi  
   
  echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"  
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
 mlibtoolize()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--verbose --install --force"  
   
  libtoolize ${opts} || die "running: mlibtoolize ${opts}"  
 }  
   
 mautoreconf()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--verbose --install --force"  
   
  autoreconf ${opts} || die "running: mautoreconf ${opts}"  
 }  
   
 minstalldocs()  
 {  
  local docfiles  
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  local i  
  for i in ${docfiles}  
  do  
  if [ -f ${i} ]  
  then  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  fi  
  done  
 }  
   
 mstriplibs()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"  
  find ${stripdir} ! -type d | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null  
 }  
   
 mstripbins()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"  
  find ${stripdir} ! -type d | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null  
 }  
   
 mstripstatic()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"  
  find ${stripdir} ! -type d | xargs file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null  
 }  
   
 mcompressdocs()  
 {  
  local bindir="$@"  
   
  if [ -d ${bindir}/usr/share/man ]  
  then  
  echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"  
  ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man  
  fi  
   
  if [ -d ${bindir}/usr/share/info ]  
  then  
  echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"  
  ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info  
  fi  
 }  
   
 sminclude()  
 {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment()  
 {  
  if [ -x /usr/bin/distcc ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
  # creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment()  
 {  
  if [ -x /usr/bin/ccache ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps()  
 {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  # ignore empty lines  
  [[ -z ${dep} ]] && continue  
   
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions which should also be added  
 #                         warning: they get killed before the build starts !  
 #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent  
 #   SPLIT_PACKAGE_BASE    base package name for splitpackages  
 #                         (only in the resulting magefile}  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local split_pkg_base  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [[ $1 = --target ]] && shift && target="-$1"  
   
  # mark package as splitpackage  
  [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"  
  echo "${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
   
  # split package base  
  echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  fi  
   
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  # a CRLF is needed here!  
  echo >> ${dest}  
  fi  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  typeset -f postinstall >> ${dest}  
  typeset -f preremove >> ${dest}  
  typeset -f postremove >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local subpackage  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [[ -n ${MAGE_TARGETS} ]]  
  then  
  # build for each target a mage file  
  # run it with several targets  
  echo  
  for subpackage in ${MAGE_TARGETS}  
  do  
  build_mage_script --target "${subpackage}"  
  done  
  echo  
   
  # run it for splitpackages  
  elif [[ -n ${SPLIT_PACKAGES} ]]  
  then  
  local split_pkg_base="${PNAME}"  
  # save smage environment  
  split_save_variables  
  # build for each subpackage a mage file  
  # run it with several targets  
  echo  
  for subpackage in ${SPLIT_PACKAGES}  
  do  
  # get the right variables for the split  
  export PNAME="${subpackage}"  
  split_info_${subpackage}  
  # get the preinstall etc  
  split_export_inherits ${subpackage}  
  build_mage_script --split-pkg-base "${split_pkg_base}"  
  # delete split preinstall etc  
  split_delete_inherits ${subpackage}  
  # restore smage environment  
  split_restore_variables  
  done  
  echo  
  # unset all saved smage variables  
  split_unset_variables  
   
  else  
  echo  
  build_mage_script  
  echo  
  fi  
  fi  
   
  # now unset all uneeded vars to be safe  
  # unset PKGNAME <-- don't do that; smage needs this var  
  # unset to be safe (quotes needed !)  
 # for i in ${SPECIAL_FUNCTIONS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_FUNCTIONS  
 # for i in ${SPECIAL_VARS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
   
 split_save_variables()  
 {  
  export SAVED_PNAME="${PNAME}"  
  export SAVED_PVER="${PVER}"  
  export SAVED_PBUILD="${PBUILD}"  
  export SAVED_PCATEGORIE="${PCATEGORIE}"  
  export SAVED_DESCRIPTION="${DESCRIPTION}"  
  export SAVED_HOMEPAGE="${HOMEPAGE}"  
  export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"  
  export SAVED_STATE="${STATE}"  
  export SAVED_PKGTYPE="${PKGTYPE}"  
  export SAVED_INHERITS="${INHERITS}"  
  export SAVED_DEPEND="${DEPEND}"  
  export SAVED_SDEPEND="${SDEPEND}"  
  export SAVED_PROVIDE="${PROVIDE}"  
  export SAVED_NOPKGBUILD="${NOPKGBUILD}"  
   
  # bindir too  
  export SAVED_BINDIR="${BINDIR}"  
   
  # export the SPLIT_PACKAGE_BASE  
  export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"  
   
  # functions  
  if [[ ! -z $(typeset -f preinstall) ]]  
  then  
  # rename the old one  
  local saved_preinstall  
  saved_preinstall=SAVED_$(typeset -f preinstall)  
  eval "${saved_preinstall}"  
  export -f SAVED_preinstall  
  fi  
   
  if [[ ! -z $(typeset -f postinstall) ]]  
  then  
  # rename the old one  
  local saved_postinstall  
  saved_postinstall=SAVED_$(typeset -f postinstall)  
  eval "${saved_postinstall}"  
  export -f SAVED_postinstall  
  fi  
   
  if [[ ! -z $(typeset -f preremove) ]]  
  then  
  # rename the old one  
  local saved_preremove  
  saved_preremove=SAVED_$(typeset -f preremove)  
  eval "${saved_preremove}"  
  export -f SAVED_preremove  
  fi  
   
  if [[ ! -z $(typeset -f postremove) ]]  
  then  
  # rename the old one  
  local saved_postremove  
  saved_postremove=SAVED_$(typeset -f postremove)  
  eval "${saved_postremove}"  
  export -f SAVED_postremove  
  fi  
 }  
   
 split_restore_variables()  
 {  
  export PNAME="${SAVED_PNAME}"  
  export PVER="${SAVED_PVER}"  
  export PBUILD="${SAVED_PBUILD}"  
  export PCATEGORIE="${SAVED_PCATEGORIE}"  
  export DESCRIPTION="${SAVED_DESCRIPTION}"  
  export HOMEPAGE="${SAVED_HOMEPAGE}"  
  export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"  
  export STATE="${SAVED_STATE}"  
  export PKGTYPE="${SAVED_PKGTYPE}"  
  export INHERITS="${SAVED_INHERITS}"  
  export DEPEND="${SAVED_DEPEND}"  
  export SDEPEND="${SAVED_SDEPEND}"  
  export PROVIDE="${SAVED_PROVIDE}"  
  export NOPKGBUILD="${SAVED_NOPKGBUILD}"  
   
  # bindir too  
  export BINDIR="${SAVED_BINDIR}"  
   
  # functions  
  if [[ ! -z $(typeset -f SAVED_preinstall) ]]  
  then  
  # rename the old one  
  local saved_preinstall  
  saved_preinstall=$(typeset -f SAVED_preinstall)  
  eval "${saved_preinstall/SAVED_/}"  
  export -f preinstall  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_postinstall) ]]  
  then  
  # rename the old one  
  local saved_postinstall  
  saved_postinstall=$(typeset -f SAVED_postinstall)  
  eval "${saved_postinstall/SAVED_/}"  
  export -f postinstall  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_preremove) ]]  
  then  
  # rename the old one  
  local saved_preremove  
  saved_preremove=$(typeset -f SAVED_preremove)  
  eval "${saved_preremove/SAVED_/}"  
  export -f preremove  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_postremove) ]]  
  then  
  # rename the old one  
  local saved_postremove  
  saved_postremove=$(typeset -f SAVED_postremove)  
  eval "${saved_postremove/SAVED_/}"  
  export -f postremove  
  fi  
 }  
   
 split_unset_variables()  
 {  
  # unset saved vars; not needed anymore  
  unset SAVED_PNAME  
  unset SAVED_PVER  
  unset SAVED_PBUILD  
  unset SAVED_PCATEGORIE  
  unset SAVED_DESCRIPTION  
  unset SAVED_HOMEPAGE  
  unset SAVED_SPECIAL_VARS  
  unset SAVED_STATE  
  unset SAVED_PKGTYPE  
  unset SAVED_INHERITS  
  unset SAVED_DEPEND  
  unset SAVED_SDEPEND  
  unset SAVED_PROVIDE  
  unset SAVED_BINDIR  
  unset SAVED_NOPKGBUILD  
  unset SPLIT_PACKAGE_BASE  
  unset -f SAVED_preinstall  
  unset -f SAVED_postinstall  
  unset -f SAVED_preremove  
  unset -f SAVED_postremove  
 }  
   
 split_export_inherits()  
 {  
  local subpackage="$1"  
  local func  
  local newfunc  
   
  for func in preinstall postinstall preremove postremove  
  do  
  if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]  
  then  
  newfunc=$(typeset -f ${func}_${subpackage})  
  newfunc="${newfunc/_${subpackage} (/ (}"  
  eval "${newfunc}"  
  fi  
  done  
 }  
   
 split_delete_inherits()  
 {  
  local subpackage="$1"  
  local func  
   
  for func in preinstall postinstall preremove postremove  
  do  
  if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]  
  then  
  unset -f ${func}  
  fi  
  done  
  }  
   
 export_inherits()  
 {  
  local include="$1"  
  shift  
   
  while [ "$1" ]  
  do  
  local functions="$1"  
   
  # sanity checks  
  [ -z "${include}" ] && die "export_inherits(): \$include not given."  
  [ -z "${functions}" ] && die "export_inherits(): \$functions not given."  
   
  eval "${functions}() { ${include}_${functions} ; }"  
   
  # debug  
  [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"  
   
  shift  
  done  
 }  
   
 generate_package_md5sum()  
 {  
  local dest  
  local pcat  
  local pname  
  local pver  
  local pbuild  
  local parch  
  local target  
  local pkgname  
   
  # very basic getops  
  for i in $*  
  do  
  case $1 in  
  --pcat|-c) shift; pcat="$1" ;;  
  --pname|-n) shift; pname="$1" ;;  
  --pver|-v) shift; pver="$1" ;;  
  --pbuild|-b) shift; pbuild="$1" ;;  
  --parch|a) shift; parch="$1" ;;  
  --target|t) shift; target="$1" ;;  
  esac  
  shift  
  done  
   
  # sanity checks; abort if not given  
  [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."  
  [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."  
  [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."  
  [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."  
  [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."  
   
  # check needed global vars  
  [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."  
  [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."  
   
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
   
  # build pkgname  
  pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"  
   
  # build pkg-md5-sum only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"  
   
  # abort if not exist  
  if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]  
  then  
  echo -e "${COLRED}! exists${COLDEFAULT}"  
  return 0  
  fi  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
16    
17   # setup md5 dir  # first of all include common functions
18   dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"  source ${MLIBDIR}/common.functions.sh || exit 1
19   install -d ${dest}  source @@SYSCONFDIR@@/mage.rc.global || die "@@SYSCONFDIR@@/mage.rc.global missing."
20    source ${MAGERC} || die "${MAGERC} missing."
21   # gen md5sum  source ${MLIBDIR}/mage4.functions.sh || die "${MLIBDIR}/mage4.functions.sh missing."
22   ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \  source ${MLIBDIR}/smage2.functions.sh || die "${MLIBDIR}/smage2.functions.sh missing."
23   > ${dest}/${pkgname}.md5  
24   echo -e "${COLGREEN}done${COLDEFAULT}"  # export default path
25   fi  export PATH="${PATH}:${MLIBDIR}"
26    
27    print_usage()
28    {
29     echo "Usage: $(basename $0) [option] pkgname ..."
30     echo "Options:"
31     echo "--smage"
32     echo "--src-tarball"
33     echo "--calc"
34     echo "--update"
35     echo "--download"
36     echo "--regen"
37     echo "--create-src-tarball"
38     echo "--resume"
39     echo
40     echo "Environment variables::"
41     echo " NOCOLORS=true $(basename $0) [src]install PACKAGE"
42     echo " Disables all colors in the messages."
43     echo
44  }  }
45    
46  source_pkg_build()  # very basic getops
47  {  for i in $*
48   if [[ ${PKGTYPE} = virtual ]]  do
49   then   case $1 in
50   echo "Virtual package detected; src-pkg-tarball not necessary ..."   --smage|*.${SMAGESUFFIX}) shift; SMAGENAME="$1" ;;
51   return 0   --src-tarball) shift; SRCPKGTARBALL="$1" ;;
52   fi   --calc) shift; SMAGENAME="$1" ;;
53     --update) ;;
54   if [[ ! -d ${SOURCEDIR}/${PNAME} ]]   --download) shift; SMAGENAME="$1" ;;
55   then   --regen) shift; SMAGENAME="$1" ;;
56   echo "No SRC_URI defined; src-pkg-tarball not necessary ..."   --create-src-tarball) shift; SMAGENAME="$1" ;;
57   return 0   --resume) ;;
58   fi   esac
59     shift
60   [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."  done
   
  echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"  
   
  # include the smage2 file  
  cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}  
   
  ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )  
  [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}  
  mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}  
   
  echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"  
 }  
61    
62  step_by_step()  ## setup ##
63  {  SMAGENAME="$1"
  if [[ ${STEP_BY_STEP} = true ]]  
  then  
  echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"  
  echo "Press [enter] to continue"  
  read  
  fi  
 }  
64    
65    # expand PKGDIR, BUILDDIR and BINDIR with MROOT
66    if [[ -n ${MROOT} ]]
67    then
68     export PKGDIR=${MROOT}/${PKGDIR}
69     export BUILDDIR=${MROOT}/${BUILDDIR}
70     export BINDIR=${MROOT}/${BINDIR}
71    fi
72    
73  # print out our version  # print out our version
74  showversion  showversion
75  echo  echo
76    
77  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
78  then  then
79   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
80   echo   echo
81   exit 1   exit 1
82  fi  fi
83    
84    # load supported mage features
85    load_mage_features
86    
87  # updating smage2-scripts  # updating smage2-scripts
88  if [[ $1 = update ]]  if [[ $1 = update ]]
89  then  then
# Line 1321  then Line 194  then
194    
195   regen_mage_tree   regen_mage_tree
196    
  # build several targets  
  if [[ -n ${MAGE_TARGETS} ]]  
  then  
  for target in ${MAGE_TARGETS}  
  do  
  # build md5sum for existing packages  
  generate_package_md5sum \  
  --pcat "${PCATEGORIE}" \  
  --pname "${PNAME}" \  
  --pver "${PVER}" \  
  --pbuild "${PBUILD}" \  
  --parch "${ARCH}" \  
  --target "${target}"  
  done  
   
197   # build several subpackages   # build several subpackages
198   elif [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
199   then   then
200   split_save_variables   split_save_variables
201   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
# Line 1345  then Line 203  then
203   # get the right variables for the split   # get the right variables for the split
204   export PNAME="${subpackage}"   export PNAME="${subpackage}"
205   split_info_${subpackage}   split_info_${subpackage}
206     # fix PCATEGORIE -> PCAT
207     if [[ ! -z ${PCATEGORIE} ]]
208     then
209     PCAT="${PCATEGORIE}"
210     unset PCATEGORIE
211     fi
212   # build md5sum for existing packages   # build md5sum for existing packages
213   generate_package_md5sum \   generate_package_md5sum \
214   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
215   --pname "${PNAME}" \   --pname "${PNAME}" \
216   --pver "${PVER}" \   --pver "${PVER}" \
217   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1361  then Line 225  then
225   else   else
226   # build md5sum for existing packages   # build md5sum for existing packages
227   generate_package_md5sum \   generate_package_md5sum \
228   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
229   --pname "${PNAME}" \   --pname "${PNAME}" \
230   --pver "${PVER}" \   --pver "${PVER}" \
231   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1395  fi Line 259  fi
259  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
260  then  then
261   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
262   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
263    
264   # abort if given file is not a source pkg   # abort if given file is not a source pkg
265   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1416  then Line 280  then
280   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
281  fi  fi
282    
283    if [ "$1" == "--resume" -a -n "$2" ]
284    then
285     msetfeature "resume"
286     SMAGENAME="$2"
287    fi
288    
289  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir ] && die "Error: ${MLIBDIR}/pkgbuild_dir not found. Aborting."
290  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
291   die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."   die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
292  [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."  [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
# Line 1429  fi Line 298  fi
298  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
299    
300  smagesource ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
301  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
302  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
303  SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"  SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
304    
305  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
306  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
307    
308  # auto regen mage tree if requested  if mqueryfeature "srcpkgbuild"
 regen_mage_tree  
   
 if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  
309  then  then
310   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
311   then   then
# Line 1449  then Line 315  then
315  fi  fi
316    
317  # download sources  # download sources
318  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
319    
320  # fixes some issues with these functions  # fixes some issues with these functions
321    export -f src_setup || die "src_setup export failed"
322  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
323  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
324  export -f src_check || die "src_check export failed"  export -f src_check || die "src_check export failed"
# Line 1460  export -f src_install || die "src_instal Line 327  export -f src_install || die "src_instal
327  # fixes some compile issues  # fixes some compile issues
328  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
329  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
330  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
331    then
332     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
333    else
334     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
335    fi
336    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
337  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
338  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
339    
   
340  # setup distcc  # setup distcc
341  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
342  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
343    
344    # setup icecc
345    # setup for icecc goes *before* ccache, so ccache comes before icecc in path
346    mqueryfeature "icecc" && setup_icecc_environment
347    
348  # setup ccache  # setup ccache
349  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
350    
351  # clean up builddir if a previously one exist  if mqueryfeature "resume"
 if [ -d ${BUILDDIR} ]  
352  then  then
353   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
354    
355  # clean up srcdir if a previously unpacked one exist   # setup build logging
356  if [ -d ${SRCDIR} ]   [[ ! -d /var/log/smage ]] && install -d /var/log/smage
357  then   if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
358   rm -rf ${SRCDIR}   then
359  fi   bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
360     fi
361     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
362    
363  # clean up bindir if a previous build exist or create a new one  else
364  if [ -d ${BINDIR} ]   # clean up builddir if a previously one exist
365  then   if [ -d ${BUILDDIR} ]
366   rm -rf ${BINDIR}   then
367     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
368     fi
369     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
370    
371     # clean up srcdir if a previously unpacked one exist
372     if [ -d ${SRCDIR} ]
373     then
374     rm -rf ${SRCDIR}
375     fi
376    
377     # clean up bindir if a previous build exist or create a new one
378     if [ -d ${BINDIR} ]
379     then
380     rm -rf ${BINDIR}
381     fi
382     install -d ${BINDIR} || die "couldn't create \$BINDIR."
383    
384     # clean up package temp dir if a previous build exist
385     if [ -d ${BUILDDIR}/${PKGNAME} ]
386     then
387     rm -rf ${BUILDDIR}/${PKGNAME}
388     fi
389    
390     # clean up stamps dir
391     if [ -d ${BUILDDIR}/.stamps ]
392     then
393     rm -rf ${BUILDDIR}/.stamps
394     fi
395    
396     # setup build logging
397     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
398     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
399  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
400    
401  # cleans up package temp dir if a previous build exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
402  then  then
403   rm -rf ${BUILDDIR}/${PKGNAME}   echo "virtual package detected; nothing will be build ..."
404     # automatically set !pkgbuild here too
405     msetfeature "!pkgbuild"
406    else
407     ( run_resume src_setup || src_setup ) | ${SMAGE_LOG_CMD}
408     die_pipestatus 0 "src_setup failed"
409     resume_stamp src_setup
410     step_by_step src_setup
411    
412     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
413     die_pipestatus 0 "src_prepare failed"
414     resume_stamp src_prepare
415     step_by_step src_prepare
416    
417     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
418     die_pipestatus 0 "src_compile failed"
419     resume_stamp src_compile
420     step_by_step src_compile
421    
422     # only run checks if requested
423     if mqueryfeature "!check"
424     then
425     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
426     else
427     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
428     die_pipestatus 0 "src_check failed"
429     resume_stamp src_check
430     fi
431     step_by_step src_check
432    
433     # build several subpackages
434     if [[ -n ${SPLIT_PACKAGES} ]]
435     then
436     # save bindir & pname
437     split_save_variables
438     export SAVED_BINDIR="${BINDIR}"
439     for subpackage in ${SPLIT_PACKAGES}
440     do
441     split_info_${subpackage}
442     if [[ ${PKGTYPE} = virtual ]]
443     then
444     echo
445     echo -en "${COLBLUE}*** ${COLDEFAULT}"
446     echo -en "Virtual package detected"
447     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
448     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
449    
450     echo "virtual package detected; nothing will be build ..."
451     # automatically set !pkgbuild here too
452     msetfeature "!pkgbuild"
453     else
454     if typeset -f src_install_${subpackage} > /dev/null
455     then
456     # export subpackage bindir
457     export BINDIR="${SAVED_BINDIR}_${subpackage}"
458     # export PNAME, several internal function and include
459     # rely on this variable
460     export PNAME="${subpackage}"
461    
462     echo
463     echo -en "${COLBLUE}*** ${COLDEFAULT}"
464     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
465     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
466     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
467    
468     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
469     die_pipestatus 0 "src_install_${subpackage} failed"
470     resume_stamp src_install_${subpackage}
471     step_by_step src_install_${subpackage}
472     fi
473     fi
474     # restore smage environment
475     split_restore_variables
476     done
477     # unset all saved smage variables
478     split_unset_variables
479     else
480     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
481     die_pipestatus 0 "src_install failed"
482     resume_stamp src_install
483     step_by_step src_install
484     fi
485  fi  fi
486    
487  # setup build logging  # echo for sake of good-looking
488  [[ ! -d /var/log/smage ]] && install -d /var/log/smage  echo
 echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log  
   
 src_prepare | ${SMAGE_LOG_CMD}  
 die_pipestatus 0 "src_prepare failed"  
 step_by_step $_  
   
 src_compile | ${SMAGE_LOG_CMD}  
 die_pipestatus 0 "src_compile failed"  
 step_by_step $_  
489    
490  # only run checks if requested  if mqueryfeature "!compressdoc"
 if [[ ${MAGE_CHECK} != true ]]  
491  then  then
492   echo "MAGE_CHECK not requested; src_check() will not be run!" | ${SMAGE_LOG_CMD}   echo -e "!compressdoc detected; documentation will not be compressed ..."
493   step_by_step src_check  elif mqueryfeature "!pkgbuild"
494    then
495     echo "!pkgbuild detected; skipping documentation compression..."
496  else  else
497   src_check | ${SMAGE_LOG_CMD}   # compressing doc, info & man files
498   die_pipestatus 0 "src_check failed"   if [[ -n ${SPLIT_PACKAGES} ]]
499   step_by_step $_   then
500     # save smage environment
501     split_save_variables
502     for subpackage in ${SPLIT_PACKAGES}
503     do
504     # honor split_info
505     split_info_${subpackage}
506     if [[ ${PKGTYPE} = virtual ]]
507     then
508     # automatically set !pkgbuild here too
509     msetfeature "!pkgbuild"
510     fi
511    
512     if mqueryfeature "!compressdoc"
513     then
514     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
515     elif mqueryfeature "!pkgbuild"
516     then
517     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
518     else
519     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
520     resume_stamp post-mcompressdoc_${subpackage}
521     fi
522     # restore smage environment
523     split_restore_variables
524     done
525     # unset saved variables
526     split_unset_variables
527     else
528     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
529     resume_stamp post-mcompressdoc
530     fi
531  fi  fi
532    
533  # build several subpackages  if mqueryfeature "!libtool"
 if [[ -n ${SPLIT_PACKAGES} ]]  
534  then  then
535   # save bindir & pname   if mqueryfeature "!pkgbuild"
536   split_save_variables   then
537   export SAVED_BINDIR="${BINDIR}"   echo "!pkgbuild detected; skipping libtool archive stripping ..."
538   for subpackage in ${SPLIT_PACKAGES}   else
539   do   if [[ -n ${SPLIT_PACKAGES} ]]
  if typeset -f src_install_${subpackage} > /dev/null  
540   then   then
541   # export subpackage bindir   # save smage environment
542   export BINDIR="${SAVED_BINDIR}_${subpackage}"   split_save_variables
543   # export PNAME, several internal function and include   for subpackage in ${SPLIT_PACKAGES}
544   # rely on this variable   do
545   export PNAME="${subpackage}"   # honor split_info
546     split_info_${subpackage}
547     if [[ ${PKGTYPE} = virtual ]]
548     then
549     # automatically set !pkgbuild here too
550     msetfeature "!pkgbuild"
551     fi
552    
553     if mqueryfeature "!libtool"
554     then
555     if mqueryfeature "!pkgbuild"
556     then
557     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
558     else
559     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
560     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
561     resume_stamp post-mstriplibtoolarchive_${subpackage}
562     fi
563     fi
564    
565   echo   # restore smage environment
566   echo -en "${COLBLUE}*** ${COLDEFAULT}"   split_restore_variables
567   echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"   done
568   echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"   # unset saved variables
569   echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."   split_unset_variables
570     else
571   src_install_${subpackage} | ${SMAGE_LOG_CMD}   echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
572   die_pipestatus 0 "src_install_${subpackage} failed"   run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
573   step_by_step $_   resume_stamp post-mstriplibtoolarchive
574   fi   fi
575   done   fi
  # restore bindir & pname  
  split_restore_variables  
  # unset all saved smage variables  
  split_unset_variables  
 else  
  src_install | ${SMAGE_LOG_CMD}  
  die_pipestatus 0 "src_install failed"  
  step_by_step $_  
576  fi  fi
577    
578  # compressing doc, info & man files  if mqueryfeature "purge"
 if [[ -n ${SPLIT_PACKAGES} ]]  
579  then  then
580   for subpackage in ${SPLIT_PACKAGES}   if mqueryfeature "!pkgbuild"
581   do   then
582   mcompressdocs ${BINDIR}_${subpackage}   echo "!pkgbuild detected; skipping file purgation ..."
583   done   else
 else  
  mcompressdocs ${BINDIR}  
 fi  
   
   
 # stripping all bins and libs  
 case ${NOSTRIP} in  
  true|TRUE|yes|y)  
  echo -e "NOSTRIP=true detected; Package will not be stripped ..."  
  ;;  
  *)  
584   if [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
585   then   then
586     # save smage environment
587     split_save_variables
588   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
589   do   do
590   echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"   # honor split_info
591   mstripbins ${BINDIR}_${subpackage}   split_info_${subpackage}
592   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"   if [[ ${PKGTYPE} = virtual ]]
593   mstriplibs ${BINDIR}_${subpackage}   then
594   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"   # automatically set !pkgbuild here too
595   mstripstatic ${BINDIR}_${subpackage}   msetfeature "!pkgbuild"
596     fi
597    
598     if mqueryfeature "purge"
599     then
600     if mqueryfeature "!pkgbuild"
601     then
602     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
603     else
604     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
605     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
606     resume_stamp post-mpurgetargets_${subpackage}
607     fi
608     fi
609    
610     # restore smage environment
611     split_restore_variables
612   done   done
613     # unset saved variables
614     split_unset_variables
615   else   else
616   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
617   mstripbins ${BINDIR}   run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
618   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"   resume_stamp post-mpurgetargets
  mstriplibs ${BINDIR}  
  echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"  
  mstripstatic ${BINDIR}  
619   fi   fi
620   ;;   fi
621  esac  fi
622    
623    # stripping all bins and libs
624    if mqueryfeature "!strip"
625    then
626     echo -e "!strip detected; package will not be stripped ..."
627    elif mqueryfeature "!pkgbuild"
628    then
629     echo "!pkgbuild detected; skipping stripping of the package ..."
630    else
631     if [[ -n ${SPLIT_PACKAGES} ]]
632     then
633     # save smage environment
634     split_save_variables
635     for subpackage in ${SPLIT_PACKAGES}
636     do
637     # honor split_info
638     split_info_${subpackage}
639     if [[ ${PKGTYPE} = virtual ]]
640     then
641     # automatically set !pkgbuild here too
642     msetfeature "!pkgbuild"
643     fi
644    
645     if mqueryfeature "!strip"
646     then
647     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
648     elif mqueryfeature "!pkgbuild"
649     then
650     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
651     else
652     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
653     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
654     resume_stamp post-mstripbins_${subpackage}
655     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
656     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
657     resume_stamp post-mstriplibs_${subpackage}
658     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
659     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
660     resume_stamp post-mstripstatic_${subpackage}
661     fi
662    
663     # restore smage environment
664     split_restore_variables
665     done
666     # unset saved variables
667     split_unset_variables
668     else
669     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
670     run_resume post-mstripbins || mstripbins ${BINDIR}
671     resume_stamp post-mstripbins
672     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
673     run_resume post-mstriplibs || mstriplibs ${BINDIR}
674     resume_stamp post-mstriplibs
675     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
676     run_resume post-mstripstatic || mstripstatic ${BINDIR}
677     resume_stamp post-mstripstatic
678     fi
679    fi
680    
681  # the new buildpkg command  if mqueryfeature "qalint"
682  case ${NOPKGBUILD} in  then
683   true|TRUE|yes|y)   if mqueryfeature "!pkgbuild"
684   echo -e "NOPGKBUILD=true detected; Package will not be build ..."   then
685   ;;   echo "!pkgbuild detected; skipping QA lint checks ..."
686   *)   else
687   # build several targets   if [[ -n ${SPLIT_PACKAGES} ]]
  if [[ -n ${MAGE_TARGETS} ]]  
688   then   then
689   for target in ${MAGE_TARGETS}   # save smage environment
690     split_save_variables
691     for subpackage in ${SPLIT_PACKAGES}
692   do   do
693   # check if a special target_pkgbuild exists   # honor split_info
694   if typeset -f ${target}_pkgbuild > /dev/null   split_info_${subpackage}
695     if [[ ${PKGTYPE} = virtual ]]
696   then   then
697   # run it   # automatically set !pkgbuild here too
698   ${target}_pkgbuild   msetfeature "!pkgbuild"
699   fi   fi
  # now create the target package  
  ${MLIBDIR}/pkgbuild_dir.sh \  
  "${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD}" \  
  ${BINDIR} || die "target: ${target} package-build failed"  
700    
701   # build pkg-md5-sum if requested   if mqueryfeature "qalint"
702   generate_package_md5sum \   then
703   --pcat "${PCATEGORIE}" \   if mqueryfeature "!pkgbuild"
704   --pname "${PNAME}" \   then
705   --pver "${PVER}" \   echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
706   --pbuild "${PBUILD}" \   else
707   --parch "${ARCH}" \   echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
708   --target "${target}"   mqalint ${BINDIR}_${subpackage}
709     fi
710     fi
711    
712   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   # restore smage environment
713     split_restore_variables
714   done   done
715     # unset saved variables
716     split_unset_variables
717     else
718     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
719     mqalint ${BINDIR}
720     fi
721     fi
722    fi
723    
724    if mqueryfeature "!pkgbuild"
725    then
726     echo -e "!pkgbuild detected; Package will not be build ..."
727    else
728   # build several subpackages   # build several subpackages
729   elif [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
730   then   then
731   split_save_variables   split_save_variables
732   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
# Line 1641  case ${NOPKGBUILD} in Line 734  case ${NOPKGBUILD} in
734   # get the right variables for the split   # get the right variables for the split
735   export PNAME="${subpackage}"   export PNAME="${subpackage}"
736   split_info_${PNAME}   split_info_${PNAME}
737     # fix PCATEGORIE -> PCAT
738     if [[ ! -z ${PCATEGORIE} ]]
739     then
740     PCAT="${PCATEGORIE}"
741     unset PCATEGORIE
742     fi
743     if [[ ${PKGTYPE} = virtual ]]
744     then
745     # automatically set !pkgbuild here too
746     msetfeature "!pkgbuild"
747     fi
748    
749   # jump to next one if NOPKGBUILD is set in split_info   # jump to next one if !pkgbuild is set in split_info
750   case ${NOPKGBUILD} in   if mqueryfeature "!pkgbuild"
751   true|TRUE|yes|y) continue ;;   then
752   esac   # restore smage environment
753     split_restore_variables
754     continue
755     fi
756    
757   # check if an special subpackage_pkgbuild exists   # check if an special subpackage_pkgbuild exists
758   if typeset -f ${PNAME}_pkgbuild > /dev/null   if typeset -f ${PNAME}_pkgbuild > /dev/null
759   then   then
760   # run it   # run it
761   ${PNAME}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
762     resume_stamp post-${PNAME}_pkgbuild
763   fi   fi
764   # now create the target package   # now create the target package
765   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir \
766   "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
767   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
768     resume_stamp post-pkg_builddir_${PNAME}
769    
770   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
771   generate_package_md5sum \   run_resume post-md5sum_${PNAME} || generate_package_md5sum \
772   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
773   --pname "${PNAME}" \   --pname "${PNAME}" \
774   --pver "${PVER}" \   --pver "${PVER}" \
775   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
776   --parch "${ARCH}"   --parch "${ARCH}"
777     resume_stamp post-md5sum_${PNAME}
778    
779   echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
780    
781   # restore smage environment   # restore smage environment
782   split_restore_variables   split_restore_variables
# Line 1675  case ${NOPKGBUILD} in Line 785  case ${NOPKGBUILD} in
785   split_unset_variables   split_unset_variables
786    
787   else   else
788   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir ${PKGNAME} ${BINDIR} || die "package-build failed"
789     resume_stamp post-pkg_builddir
790    
791   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
792   generate_package_md5sum \   run_resume post-md5sum || generate_package_md5sum \
793   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
794   --pname "${PNAME}" \   --pname "${PNAME}" \
795   --pver "${PVER}" \   --pver "${PVER}" \
796   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
797   --parch "${ARCH}"   --parch "${ARCH}"
798     resume_stamp post-md5sum
799    
800   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
801   fi   fi
802    
803   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
804   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   if mqueryfeature "srcpkgbuild"
805   ;;   then
806  esac   run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
807     resume_stamp post-srcpkgbuild
808     fi
809    fi
810    
811  if [[ ${SMAGE_BUILD_LOGGING} != false ]]  # auto regen mage tree if requested
812    regen_mage_tree
813    
814    if mqueryfeature "buildlog"
815  then  then
816   bzip2 -9f /var/log/smage/${PKGNAME}.log   bzip2 -9f /var/log/smage/${PKGNAME}.log
817  else  else
818   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
819  fi  fi
820    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
821  xtitleclean  xtitleclean

Legend:
Removed from v.1578  
changed lines
  Added in v.2743